C---------------------------------------------------------
C    TOOLPACK/1    Release: 2.4
C---------------------------------------------------------
C
C This file is used together with GRAMMR.YP to create a
C new YYPARS.MAC using YACC.  It replaces /usr/lib/yaccpar.
C The resultant YACC output is not quite Fortran and still
C needs extensive editing to change it so that it is.
C This editing is, however, quite straightforward.
C
 
 
C * Parser for yacc output *
 
        INTEGER FUNCTION YYPARS()
 
C * YYV: Where the values are stored
C   YYCHAR: Current input token number
C   YYNERR: Number of errors
C   YYERRF: Error recovery flag
C
C   YYVAL: Action value of non-terminal
C   YYLVAL: Action value of terminal
C   YYPVT: Pointer into YYV during action
C
C   YYS: State stack
C   YYPS,YYPV: Stack pointers for YYS & YYV
C *
C
C   YYSTA - Current state
C   YYXI - Index into YYEXCA
C   YYJ, YYM - Temporaries
C   YYN - Production number
C *
 
        LOGICAL YDEBUG
        INTEGER YYFLAG
        PARAMETER (YDEBUG=.FALSE.,YYFLAG=-1000)
 
        INTEGER YYCHAR,YYNERR,YYERRF,YYPS,YYPV,YYVAL,YYLVAL,YYPVT
 
        INTEGER YYS(0:YYMAXDEPTH-1),YYV(0:YYMAXDEPTH-1)
        INTEGER YYR1(0:YYNPROD-1),YYR2(0:YYNPROD-1),YYACT(0:YYLAST-1)
 
        INTEGER YYEXCA(0:****),YYPACT(0:****),YYPGO(0:****),
     +          YYCHK(0:****),YYDEF(0:****)
 
        INTEGER YYXI,YYSTA,YYJ,YYM,YYN
 
        INTEGER YYLEX
        EXTERNAL YYLEX,ZCHOUT,PUTDEC,PUTC
 
**** <<<<MOVE TABLES TO HERE>>>> ****
 
        DATA YYV/YYMAXDEPTH*0/
        YYCHAR=-1
        YYSTA=0
        YYPS=-1
        YYPV=-1
        YYNERR=0
        YYERRF=0
        YYVAL=0
 
666     CONTINUE
 
C * Put a state and value onto the stack *
 
27100        CONTINUE
        IF (YDEBUG) THEN
            CALL ZCHOUT('State ',1)
            CALL PUTDEC(YYSTA,1)
            CALL ZCHOUT(', token ',1)
            CALL PUTDEC(YYCHAR,1)
            CALL PUTC(10)
        END IF
        YYPS=YYPS+1
        IF (YYPS.GE.YYMAXDEPTH) THEN
            CALL YERROR('Yacc stack overflow')
            GOTO27400
        END IF
        YYS(YYPS)=YYSTA
        YYPV=YYPV+1
        YYV(YYPV)=YYVAL
 
27200        CONTINUE
        YYN=YYPACT(YYSTA)
C Simple state?
        IF (YYN.LE.yyflag) GOTO 27300
        IF (YYCHAR.LT.0) THEN
            YYCHAR=YYLEX(YYLVAL)
            IF (YYCHAR.LT.0) YYCHAR=0
        END IF
        YYN=YYN+YYCHAR
        IF (YYN.LT.0 .OR. YYN.GE.YYLAST) GOTO 27300
C Valid shift?
        YYN=YYACT(YYN)
        IF (YYCHK(YYN).EQ.YYCHAR) THEN
C Yes
            YYCHAR=-1
            YYVAL=YYLVAL
            YYSTA=YYN
            IF (YYERRF.GT.0) YYERRF=YYERRF-1
            GOTO 27100
        END IF
 
C * Default state action *
 
27300        CONTINUE
        YYN=YYDEF(YYSTA)
        IF (YYN.EQ.-2) THEN
            IF (YYCHAR.LT.0) THEN
                YYCHAR=YYLEX(YYLVAL)
                IF (YYCHAR.LT.0) YYCHAR=0
            END IF
C Look through exception table
            YYXI=-2
27310       YYXI=YYXI+2
            IF (YYEXCA(YYXI).NE.-1 .OR. YYEXCA(YYXI+1).NE.YYSTA)
     +          GOTO 27310
27320       YYXI=YYXI+2
            IF(YYEXCA(YYXI).GE.0 .AND. YYEXCA(YYXI).NE.YYCHAR)GOTO 27320
C Accept
            YYN=YYEXCA(YYXI+1)
            IF (YYN.LT.0) THEN
                YYPARS=0
                RETURN
            END IF
        END IF
 
C * Error? *
 
        IF (YYN.NE.0) GOTO 27370
        IF (YYERRF.EQ.3) GOTO 27360
C Yes - attempt to resume parsing
        IF (YYERRF.EQ.0) CALL YERROR('Syntax Error')
27350        CONTINUE
        YYNERR=YYNERR+1
        YYERRF=3
C Find a state where "Error" is a legal shift action
27351   IF (YYS(YYPS).GE.0) THEN
            YYN=YYPACT(YYS(YYPS))+YYERRCODE
            IF (YYN.GE.0 .AND. YYN.LT.YYLAST) THEN
                IF (YYCHK(YYACT(YYN)).EQ.YYERRCODE) THEN
C Simulate a shift of "Error"
                    YYSTA=YYACT(YYN)
                    GOTO 27100
                END IF
            END IF
            YYN=YYPACT(YYS(YYPS))
C The current yys(yyps) has no shift on "Error", pop stack
            IF (YDEBUG) THEN
                CALL ZCHOUT('Error recovery pops state ',1)
                CALL PUTDEC(YYS(YYPS),1)
                CALL ZCHOUT(', uncovers ',1)
                CALL PUTDEC(YYS(YYPS-1),1)
                CALL PUTC(10)
            END IF
            YYPS=YYPS-1
            YYPV=YYPV-1
            IF (YYPS.GE.0) GOTO 27351
        END IF
C There is no state on the stack with an error shift - abort
        GOTO27400
 
C Case YYERRF .EQ. 3
 
27360   CONTINUE
 
C No shift yet, clobber input char
 
        IF (YDEBUG) THEN
            CALL ZCHOUT('Error recovery discards token ',1)
            CALL PUTDEC(YYCHAR,1)
            CALL PUTC(10)
        END IF
        IF (YYCHAR.EQ.0) GOTO 27400
        YYCHAR=-1
        GOTO 27200
 
27370   CONTINUE
 
C * Reduction by production YYN *
 
        IF (YDEBUG) THEN
            CALL ZCHOUT('Reduce ',1)
            CALL PUTDEC(YYN,1)
            CALL PUTC(10)
        END IF
        YYPS=YYPS-YYR2(YYN)
        YYPVT=YYPV
        YYPV=YYPV-YYR2(YYN)
        YYVAL=YYV(YYPV+1)
        YYM=YYN
C * Consult goto table to find next state *
        YYN=YYR1(YYN)
        YYJ=YYPGO(YYN)+YYS(YYPS)+1
        IF (YYJ.GE.YYLAST) THEN
            YYSTA=YYACT(YYPGO(YYN))
        ELSE
            YYSTA=YYACT(YYJ)
            IF (YYCHK(YYSTA).NE.(-YYN)) YYSTA=YYACT(YYPGO(YYN))
        END IF
        GOTO (...) YYM
C If there are no actions, just stack new state and value
 
C Otherwise default action
        GOTO 27100
 
        $A
 
C All actions, including the last, should end with "GOTO yystack"
 
27400        CONTINUE
        YYPARS=1
        RETURN
 
        END
